/*
  Manual joystick controller for MPCNC
  V0.3, August 25, 2019
  (C) Armin Thinnes 2019
  Changelog:
  Implement treshold for bad joysticks not zeroing correctly 
  Swapped order of movements (higher first)
  Implement individually configurable 100mm mode for x and y including disabling 100mm mode completely 
*/

// These constants won't change. They're used to give names to the pins used:
// user configurable options
const long baud_rate=250000; // Baudrate of your MPCNC-Controller

const int home_xy=2; // home_xy button pin D2
const int home_xy_led=3; // Home XY LED pin D3

const int home_z=4; // home_z button pin D4
const int home_z_led=5; // Home Z LED pin D5

const int reset_coordinates=6; // reset_coordinates button D6
const int reset_coords_led=7; // Reset Coords LED D7

const int enable=8; // enable button pin D8
const int enable_led=9; // enable LED pin D9


//const int reset_Z=7; // reset_ccordinates button D7 (Joystick Button)



boolean en = false;
boolean hxy = false; //define buttons_presed variables
boolean hz = false;
boolean rc = false;

void setup() {

  pinMode(enable_led, OUTPUT);
  pinMode(home_xy_led, OUTPUT);
  pinMode(home_z_led, OUTPUT);
  pinMode(reset_coords_led, OUTPUT);
  pinMode(enable, INPUT_PULLUP);
  pinMode(home_xy, INPUT_PULLUP);
  pinMode(home_z, INPUT_PULLUP);
  pinMode(reset_coordinates, INPUT_PULLUP);
  
  delay(1000);;
                    
}

void loop() {

  en = digitalRead(enable);
  hxy = digitalRead(home_xy);
  hz = digitalRead(home_z);
  rc = digitalRead(reset_coordinates);

 if(!(en)) {
   digitalWrite(enable_led, 1);
   if (!(hxy)) 
   {
    digitalWrite(home_xy_led, 1);
    Serial.begin(baud_rate); //open serial port
    Serial.println("M117 Home XY...");
    Serial.println("G28 X Y");
    Serial.end();//close serial port to avoid problems with Octoprint
    delay(1000);
    digitalWrite(home_xy_led, 0);
   } else if (!(hz))
   {
    digitalWrite(home_z_led, 1);
    Serial.begin(baud_rate);//open serial port
    Serial.println("M117 Home Z...");
    Serial.println("G28 Z");
    Serial.println("G92 Z20");
    Serial.println("G0 Z25 F300");
    Serial.end();//close serial port to avoid problems with Octoprint
    delay(1000);
    digitalWrite(home_z_led, 0);
   } else if (!(rc)) 
   {
    digitalWrite(reset_coords_led, 1);
    Serial.begin(baud_rate); //open serial port
    Serial.println("M117 Reset X Y coordinates");
    Serial.println("G92 X0 Y0");
    Serial.println("M300 S300 P1000");
    Serial.end();//close serial port to avoid problems with Octoprint
    delay(1000);
    digitalWrite(reset_coords_led, 0);
    }
  } else {
     digitalWrite(enable_led, 0);
  }
}
